#include <stdlib.h>
#include <stdio.h>

#include "xmalloc.h"
#include "list.h"

static void
freedata(void *data)
{
	free(data);
}

int
list_test()
{
	struct slist *list, *e1, *e2, *e3;
	struct slist *iter, *next;
	void *datatab[3];
	int i;

	list = NULL;

	e1 = slist_new();
	e1->data = xmalloc0(64);
	datatab[1] = e1->data;

	e2 = slist_new();
	e2->data = xmalloc(64);
	datatab[0] = e2->data;

	e3 = slist_new();
	e3->data = xmalloc(64);
	datatab[2] = e3->data;

	list = slist_add(list, e1);
	list = slist_add(list, e2);
	list = slist_add_tail(list, e3);

	i = 0;
	for (iter = list; iter != NULL; iter = iter->next) {
		if (iter->data != datatab[i]) {
			fprintf(stderr, "invalid order of elements in the list\n");
			return 1;
		}
		++i;
	}

	slist_free_all(&list, freedata);

	e1 = slist_new();
	e2 = slist_new();
	e3 = slist_new();

	list = slist_add(list, e1);
	list = slist_add(list, e2);
	list = slist_add(list, e3);

	for (iter = list; iter != NULL; iter = next) {
		next = iter->next;
		slist_free(&iter);
	}

	return 0;
}

int
main(int argc, char *argv[])
{
	int res;
	const char *msg[] = { "ok", "failed" };

	res = list_test();

	printf("list_test: %s\n", msg[res]);

	return res;
}
